Redmine - Defect #10048

Secondary sorting after sorting by parent task
2012-01-24 13:06 - Janis Elmeris

Status: New Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Issues Estimated time: 0.00 hour

Target version:

Resolution: Affected version: 1.3.0

Description

I've created a custom query with two sort orders: 1) Parent task - Ascending (as | want my subtasks be grouped visually together), 2)
Updated - Descending (as | want to see the most recently changed tasks at the top).

What | would expect is that

1. all the tasks without parents would be sorted by their "Updated"” value;
2. all the subtasks within the same parent task would be sorted by their "Updated” value.

As can be seen in the attached screenshot, the actual result in the example of "http://www.redmine.org/projects/redmine/issues" is all
the non-parent tasks sorted by their IDs.

All the versions to be submitted along with a bug reports, please take from the current http://www.redmine.org installation, where I'm
submitting the defect in. The test screenshot is taken from here.

redmine-sorting.png

Related issues:

Related to Redmine - Feature #7907: Display Issues in a hierarchy (tree) New 2011-03-17
Has duplicate Redmine - Defect #14432: Sorting issues with subtasks Closed

Has duplicate Redmine - Defect #20123: Can't sort by multiple fields when sor... Closed

Has duplicate Redmine - Defect #31840: Sort by Parent does not work as expected Closed

Has duplicate Redmine - Defect #34818: Do not display in the order set in the... Closed

Has duplicate Redmine - Defect #38618: it seems to be sorted by issue number ... Closed

History

#1 - 2012-03-05 04:11 - Philip Reinders

| am seeing the same problem. Sort of curious what is going on with this one as it is fairly critical for my implementation.

#2 - 2012-03-15 11:52 - Vitaly Klimov

Please check my plugin - it solves this behavior:

http://www.redmine.org/plugins/redmine_smart_issues_sort

#3 - 2012-12-10 22:42 - Asaf H

+1
We have the same issue. It's problematic as | want to sort issues by priorities, but still have the subtasks grouped under their parent.

#4 - 2013-03-25 06:43 - John Pisani
+1

Parent, Priority just ignores the latter.

#5 - 2013-03-26 07:58 - Dipan Mehta

+1. This is indeed very essential to be in Redmine.

#6 - 2013-03-27 16:44 - Anton Potapov

+1 vote for it
http://www.redmine.org
http://www.redmine.org/plugins/redmine_smart_issues_sort

#7 - 2013-07-19 09:26 - Toshi MARUYAMA
- Has duplicate Defect #14432: Sorting issues with subtasks added

#8 - 2013-10-01 01:07 - Sergio Cambra

+1 | have this problem too

#9 - 2013-10-15 11:46 - Zdravko Balorda

Any news on this?

redmine_smart_issues_sort wouldn't run on 2.3, saying:
undefined method 'issues' for class '‘Query’

on line 12 lib/query_patch.rb

Any clues are most appreciated.
Zdravko

#10 - 2014-02-05 16:58 - Nicolas Ph

Well, i have the same issue, a custom query with "Parent task" as first sort field, the second field is ignored, whatever it is. The result look like the
second field is set to 'Created'.

The same issue exists when sorting issue by clicking on columns : After adding the 'Parent Task' to the issue view, I click on "Updated" for example,
and then on 'Parent Task', the previous 'Updated' order is completely lost.

By the way, the gantt view with the same query seems to work right.

#11 - 2015-07-17 13:15 - Toshi MARUYAMA
- Has duplicate Defect #20123: Can't sort by multiple fields when sorting by parent added

#12 - 2015-11-13 12:11 - Matt Brooke

+1 causing us a problem and the patch doesn't seem compatible with v 3.1

#13 - 2015-11-27 09:01 - Sebastian Paluch
+100

I'm getting more and more complains about this. We have thousands of issues per project organized in a tree structure and this defect is very, very
painful.

#14 - 2017-02-27 21:13 - Josh Gitlin

+1, having the same issue, same use case. | would think this should be a simple fix... but | haven't looked at the code

#15 - 2019-06-06 18:09 - Claudio Negri

+1

#16 - 2020-02-05 10:54 - pizfantast pizfantast

+1
plugins and patches no longer work

#17 - 2020-12-23 07:45 - Go MAEDA

- Has duplicate Defect #31840: Sort by Parent does not work as expected added

#18 - 2021-02-01 10:48 - Ribald Drobens

Confirmed here as well; when 1st ordering is for parent issue, ties (i.e. no parent or same parent) are not resolved using any following filter which

makes tree-like views practically impossible.

#19 - 2021-03-01 08:36 - Go MAEDA
- Has duplicate Defect #34818: Do not display in the order set in the custom query! added

#20 - 2021-03-02 02:17 - Hirofumi Kadoya

+1

#21 - 2021-09-16 15:30 - txemi M

+1
#22 - 2021-10-15 14:42 - txemi M

+1

#23 - 2021-11-19 13:48 - Sofie vdm

+1

This is problematic, the secondary sort would be really useful, while still maintaining the parent structure.
#24 - 2022-02-24 16:47 - txemi M

In case it is useful for anyone else.

After waiting for this to be implemented | finally made my own solution.

You can find it here:

https://github.com/txemi/redmine_sorted tree

It is an small development that creates an extra index that you can use to get hierarchical tree and allows use aditional sorting criterias for deep
issues in tree.

It helps me to get human reports sorting issue tree as | want.

#25 - 2024-02-06 06:23 - Go MAEDA

- Has duplicate Defect #38618: it seems to be sorted by issue number instead of parent issue number. After that, setting the sort order has no effect at
custom query added

#26 - 2025-02-06 16:52 - Matthew Paul
- File Screenshot_11.jpg added
- File Screenshot_12.jpg added

| have a codefix for this problem but I'm using an old version (3.4) and I'm not real great with plugins etc, so | thought | could post this here since a) it
seems a lot of people have bee looking for a fix, and b) if it hasn't already been fixed in the pater versions (I'm assuming it has!) then this could be a
useful way to do this. It's kind of a hack but here we go -

e PROBLEM - On a project with a lot of parent/child tasks, you often want to sort 1) by the parent, then 2) by whatever field you want afterwards,
like status, or subject, or whatever. But a multi field sort doesn't work like that - the secondary sort is just ignored.

e CAUSE - if you look at the code under app/models/issue_query.rb, you can see under the class IssueQuery that it uses this code for a parent
sort -

QueryColumn.new(:parent, :sortable => ["#{Issue.table_name}.root_id", "#{Issue.table_name}.Ift ASC"], :default_order => 'desc', :caption =>
Afield_parent_issue),

which means that it will sort by the root_id first (the top level task) and then by the internal Ift field which is maintained internally. Some plugins are
available to move that Ift/rgt ordering around but | couldn't get those to work in my (old) version. So | wanted to change that sort.

e SOLUTION - what | want is for the upper level sort to occur with the parent level task at the top, and then all of the subtasks below,
UNORDERED. This is important, because what | want to do is sort those subtasks however | want - by subject, by ID, by status, by priority etc.
SO anyways, this is the code that does that (yeah, it's a hack, I'm sure it could be done better by pretty much anyone, but I'm desperate here!! :-)

)

Replace the code above with this -

QueryColumn.new(:parent, :sortable => ["#{Issue.table_name}.root_id", "if (#{Issue.table_name}.rgt - #{Issue.table_name}.Ift > 1,
#{lssue.table_name}.id+0, #{Issue.table_name}.parent_id+0.1) ASC"], :default_order => 'desc', :caption => ‘field_parent_issue),

So what that does is to say first of all use the root_id as normal, but then if the rgt/Ift values indicate that it's got subtasks (i.e. an rgt-Ift value over 1
indicates this) then use the id itself, but if it hasn't, then use the parent_id (i.e. the upper level) plus some additional number (I've used 0.1 here). So
the upper task will appear at the top, and subtasks below UNORDERED as you want.

EXAMPLE - this is the query | used to test it out.

Screenshot_12.jpg
Anyways, like | say this is a hack because | just use this code internally, but if anyone could build it into a simple patch or plugin or (if it hasn't already
been solved in later versions) the base code could be updated, | think this seems to work. My apologies to everyone that I'm not good enough to do
all of this properly but | thought the fix might be useful and wanted to contribute back to what | always think is the BEST all-in-one tracker/PM tool at
any price. Redmine ROCKS!
https://github.com/txemi/redmine_sorted_tree

#27 - 2025-02-06 17:47 - Matthew Paul

....actually now | think of it, if this were a plugin, it would be better if you retained the same behavior for Parent Task sort, but added an option for
something like Parent Plus or similar so people could either select the regular Parent+Lft sort, or do a Parent+whatever sort.

#28 - 2025-02-06 20:28 - Matthew Paul

PPS - only works for single level trees which is ok for me, but again if someone were better than me (ie. everyone) and could construct a sort string all
the way down that would be better. Or, as | said just include as a sort option.
